/*

	Susie Plug-in Interface


	ȉ̕WCN[ht@CKvł
		windows.h
		time.h

*/
//////////////////////////////////////////////////////////////////////
#ifndef	SPI_API_H__
#define	SPI_API_H__
	

#pragma	pack(1)
////////////////////////////////////////////////////////////
// 摜
typedef struct PictureInfo
{
	long left,top;			/* 摜WJʒu */
	long width;				/* 摜̕(pixel) */
	long height;			/* 摜̍(pixel) */
	WORD x_density;			/* f̐x */
	WORD y_density;			/* f̐x */
	short colorDepth;		/* fbit */
	HLOCAL hInfo;			/* 摜̃eLXg[Ăяo] */
} PictureInfo;

////////////////////////////////////////////////////////////
// t@C
typedef struct fileInfo
{
	unsigned char method[8];	/* k@̎ */
	unsigned long position;		/* t@Cł̈ʒu */
	unsigned long compsize;		/* kꂽTCY */
	unsigned long filesize;		/* ̃t@CTCY */
//	time_t timestamp;			/* t@C̍XV */
	long timestamp;				/* t@C̍XV */
	char path[200];				/* ΃pX */
	char filename[200];			/* t@Cl[ */
	unsigned long crc;			/* CRC */
} fileInfo;

#pragma pack()

////////////////////////////////////////////////////////////
// G[R[h
#define SPI_NO_FUNCTION			-1	/* ̋@\̓CvgĂȂ */
#define SPI_ALL_RIGHT			0	/* I */
#define SPI_ABORT				1	/* R[obN֐0Ԃ̂œWJ𒆎~ */
#define SPI_NOT_SUPPORT			2	/* m̃tH[}bg */
#define SPI_OUT_OF_ORDER		3	/* f[^Ă */
#define SPI_NO_MEMORY			4	/* [mۏoȂ */
#define SPI_MEMORY_ERROR		5	/* [G[ */
#define SPI_FILE_READ_ERROR		6	/* t@C[hG[ */
#define	SPI_WINDOW_ERROR		7	/* JȂ (J̃G[R[h) */
#define SPI_OTHER_ERROR			8	/* G[ */
#define	SPI_FILE_WRITE_ERROR	9	/* ݃G[ (J̃G[R[h) */
#define	SPI_END_OF_FILE			10	/* t@CI[ (J̃G[R[h) */


////////////////////////////////////////////////////////////
// tO/萔

/* GetPluginInfo "infono" paremeter */
enum SPI_PLUGIN_INFO { SPI_INFO_VER, SPI_INFO_ABOUT };
#define SPI_INFO_EXT(n)		(2 * n)				/* 2n	*/
#define SPI_INFO_TYPE(n)	(2 * n + 1)			/* 2n+1	*/

/* vOCo[W */
enum SPI_PLUGIN_VER {
	SPI_VER_00IN	= 0x4E493030,		/* "00IN" */
	SPI_VER_00AM	= 0x4D413030		/* "00AM" */
};

/* GetPicture, GetPictureInfo, GetFile, GetFileInfo "flag" paremeter */
enum SPI_FLAGS {
	SPI_SRC_FILE	= 0, SPI_SRC_MEMORY,			/* ͌` */
	SPI_DEST_FILE	= 0, SPI_DEST_MEMORY = 0x0100,	/* o͌` */
	SPI_IGNORECASE	= 0x80							/* 啶Eꎋ */
};

/* ConfigurationDlg function */
enum SPI_CONFIG_FLAGS {
	SPI_CONFIG_ABOUT = 0,
	SPI_CONFIG_SETTING,
	SPI_CONFIG_RESERVED
};


////////////////////////////////////////////////////////////
// Susie Plug-in Interface

#ifdef __cplusplus
extern "C" {
#endif

/* R[obN֐ */
typedef int (CALLBACK *SPI_CALLBACK)(int, int, long);

/* ʊ֐ */
int PASCAL GetPluginInfo(int infono, LPSTR buf, int buflen);
int PASCAL IsSupported(LPSTR filename, DWORD dw);
int FAR PASCAL ConfigurationDlg(HWND parent,int fnc);	// Susie v0.40ǉ

/* '00IN'̊֐ */
int PASCAL GetPictureInfo(LPSTR buf, long len, unsigned int flag, PictureInfo *lpInfo);
int PASCAL GetPicture(LPSTR buf, long len, unsigned int flag, HANDLE *pHBInfo, HANDLE *pHBm,
					  SPI_CALLBACK lpPrgressCallback, long lData);
int PASCAL GetPreview(LPSTR buf, long len, unsigned int flag, HANDLE *pHBInfo, HANDLE *pHBm,
					  SPI_CALLBACK lpPrgressCallback, long lData);

/* '00AM'̊֐ */
int PASCAL GetArchiveInfo(LPSTR buf, long len, unsigned int flag, HLOCAL *lphInf);
int PASCAL GetFileInfo(LPSTR buf, long len, LPSTR filename, unsigned int flag, fileInfo *lpInfo);
int PASCAL GetFile (LPSTR src, long len, LPSTR dest, unsigned int flag,
					SPI_CALLBACK prgressCallback, long lData);


#ifdef __cplusplus
}
#endif

#endif	// SPI_API_H__
